<?php

/* REMOVE THUMBNAILS (FOR SAVING SPACE) */
	function remove_default_image_sizes( $sizes) {
        unset( $sizes['large']);
        //unset( $sizes['thumbnail']);
        unset( $sizes['medium']);
        unset( $sizes['medium_large']);
        unset( $sizes['1536x1536']);
        unset( $sizes['2048x2048']);
        return $sizes;
    }
    add_filter('intermediate_image_sizes_advanced', 'remove_default_image_sizes');
    
    add_action( 'after_setup_theme', 'remove_images');
    function remove_images(){
	    remove_image_size( '1536x1536' );
	    remove_image_size( '2048x2048' );
    }

/* This theme uses post thumbnails */
    add_theme_support( 'post-thumbnails' );

/* Register a new image size */
	add_image_size( 'home_single_thumb', 846, 300, true);

/* Register a new menu */
	register_nav_menus( array(
		'main'	=> 'Primary Menu',
	) );
	

/** POSTS VIEWS **/
require_once( get_stylesheet_directory() . '/js/post_views.php' );


/** POSTS LIKES **/
require_once( get_stylesheet_directory() . '/js/post_likes.php' );	
	

/** 
 * THE BUTTON 'READ MORE' FOR EXCERPTS
 */


function new_excerpt_more($more) {
       global $post;
       return '<a class="morelink" href="'. get_permalink($post->ID) . '"> Read the full post…</a>';
}
add_filter('excerpt_more', 'new_excerpt_more');

function get_excerpt(){
$excerpt = get_the_content();
$excerpt = preg_replace(" ([.*?])",'',$excerpt);
$excerpt = strip_shortcodes($excerpt);
$excerpt = strip_tags($excerpt);
$excerpt = substr($excerpt, 0, 500);
$excerpt = substr($excerpt, 0, strripos($excerpt, " "));
$excerpt = trim(preg_replace( '/s+/', ' ', $excerpt));
$excerpt = $excerpt.'... <a class="morelink" href="'.$permalink.'">Read the full post...</a>';
return $excerpt;
}







/** 
 * WORDPRESS CSS MENU WALKER
 */


class CSS_Menu_Walker extends Walker {

	var $db_fields = array('parent' => 'menu_item_parent', 'id' => 'db_id');
	
	function start_lvl(&$output, $depth = 0, $args = array()) {
		$indent = str_repeat("\t", $depth);
		$output .= "\n$indent<ul>\n";
	}
	
	function end_lvl(&$output, $depth = 0, $args = array()) {
		$indent = str_repeat("\t", $depth);
		$output .= "$indent</ul>\n";
	}
	
	function start_el(&$output, $item, $depth = 0, $args = array(), $id = 0) {
	
		global $wp_query;
		$indent = ($depth) ? str_repeat("\t", $depth) : '';
		$class_names = $value = '';
		$classes = empty($item->classes) ? array() : (array) $item->classes;
		
		/* Add active class */
		if (in_array('current-menu-item', $classes)) {
			$classes[] = 'active';
			unset($classes['current-menu-item']);
		}
		
		/* Check for children */
		$children = get_posts(array('post_type' => 'nav_menu_item', 'nopaging' => true, 'numberposts' => 1, 'meta_key' => '_menu_item_menu_item_parent', 'meta_value' => $item->ID));
		if (!empty($children)) {
			$classes[] = 'has-sub';
		}
		
		$class_names = join(' ', apply_filters('nav_menu_css_class', array_filter($classes), $item, $args));
		$class_names = $class_names ? ' class="' . esc_attr($class_names) . '"' : '';
		
		$id = apply_filters('nav_menu_item_id', 'menu-item-'. $item->ID, $item, $args);
		$id = $id ? ' id="' . esc_attr($id) . '"' : '';
		
		$output .= $indent . '<li' . $id . $value . $class_names .'>';
		
		$attributes  = ! empty($item->attr_title) ? ' title="'  . esc_attr($item->attr_title) .'"' : '';
		$attributes .= ! empty($item->target)     ? ' target="' . esc_attr($item->target    ) .'"' : '';
		$attributes .= ! empty($item->xfn)        ? ' rel="'    . esc_attr($item->xfn       ) .'"' : '';
		$attributes .= ! empty($item->url)        ? ' href="'   . esc_attr($item->url       ) .'"' : '';
		
		$item_output = $args->before;
		$item_output .= '<a'. $attributes .'><span>';
		$item_output .= $args->link_before . apply_filters('the_title', $item->title, $item->ID) . $args->link_after;
		$item_output .= '</span></a>';
		$item_output .= $args->after;
		
		$output .= apply_filters('walker_nav_menu_start_el', $item_output, $item, $depth, $args);
	}
	
	function end_el(&$output, $item, $depth = 0, $args = array()) {
		$output .= "</li>\n";
	}
}





/** 
 * REGISTER WIDGETS
 */

function register_my_widgets(){
register_sidebar( array(
	
'name' => 'Main sidebar (Aemy Design Custom)',
'id' => 'homepage-sidebar',
'description' => 'This is the area where you can add any kind of widgets you want.',
'before_widget' => '<div class="sidebar_block_inside" id="%1$s">',
'after_widget' => '</div></div>',
'before_title' => '<div class="sidebar_thumb"><span class="sidebar_name"> ',
'after_title' => '</span></div><div class="sidebar_content">',
	
	) );
}

add_action( 'widgets_init', 'register_my_widgets' );

/**
 * 
 */	






/** 
 * SHORTEN POST TITLE
 */

function trim_title_chars($count, $after) {
  $title = get_the_title();
  if (mb_strlen($title) > $count) $title = mb_substr($title,0,$count);
  else $after = '';
  echo $title . $after;
}


/**
 * 
 */




/** 
 * NAVIGATION
 */
function kama_pagenavi( $before = '', $after = '', $echo = true, $args = array(), $wp_query = null ) {
	if( ! $wp_query ){
		wp_reset_query();
		global $wp_query;
	}

	//

	$default_args = array(
		'text_num_page'   => '', // 
		'num_pages'       => 10, //
		'step_link'       => 0, // 
		'dotright_text'   => '…', //
		'dotright_text2'  => '…', // 
		'back_text'       => '<<', //
		'next_text'       => '>>', // 
		'first_page_text' => '<<<', // 
		'last_page_text'  => '>>>', //
	);

	$default_args = apply_filters('kama_pagenavi_args', $default_args );

	$args = array_merge( $default_args, $args );

	extract( $args );

	$posts_per_page = (int) $wp_query->query_vars['posts_per_page'];
	$paged          = (int) $wp_query->query_vars['paged'];
	$max_page       = $wp_query->max_num_pages;

	//

	if( $max_page <= 1 ) return false; 

	if( empty( $paged ) || $paged == 0 ) 
	$paged = 1;

	$pages_to_show = intval( $num_pages );
	$pages_to_show_minus_1 = $pages_to_show-1;

	$half_page_start = floor( $pages_to_show_minus_1/2 ); //
	$half_page_end = ceil( $pages_to_show_minus_1/2 ); //

	$start_page = $paged - $half_page_start; //
	$end_page = $paged + $half_page_end; //

	if( $start_page <= 0 ) 
		$start_page = 1;
	if( ($end_page - $start_page) != $pages_to_show_minus_1 ) 
		$end_page = $start_page + $pages_to_show_minus_1;
	if( $end_page > $max_page ) {
		$start_page = $max_page - $pages_to_show_minus_1;
		$end_page = (int) $max_page;
	}

	if( $start_page <= 0 ) 
		$start_page = 1;

	//
	$out = '';

	//

	$link_base = str_replace( 99999999, '___', get_pagenum_link( 99999999 ) );
	$first_url = get_pagenum_link( 1 );
	if( false === strpos( $first_url, '?') )
		$first_url = user_trailingslashit( $first_url );

	$out .= $before . "";

		if( $text_num_page ){
			$text_num_page = preg_replace( '!{current}|{last}!', '%s', $text_num_page );
			$out.= sprintf( "<span class='page_navigation1'>$text_num_page</span>", $paged, $max_page );
		}
		// 

		if ( $back_text && $paged != 1 ) 
			$out .= '<a class="page_prevpost" href="'. ( ($paged-1)==1 ? $first_url : str_replace( '___', ($paged-1), $link_base ) ) .'">'. $back_text .'</a> ';
		// в начало
		if ( $start_page >= 2 && $pages_to_show < $max_page ) {
			$out.= '<a class="page_firstpost" href="'. $first_url .'">'. ( $first_page_text ? $first_page_text : 1 ) .'</a> ';
			if( $dotright_text && $start_page != 2 ) $out .= '<span class="page_extendpost">'. $dotright_text .'</span> ';
		}
		// 

		for( $i = $start_page; $i <= $end_page; $i++ ) {
			if( $i == $paged )
				$out .= '<span class="page_currentpost">'.$i.'</span> ';
			elseif( $i == 1 )
				$out .= '<a href="'. $first_url .'">1</a> ';
			else
				$out .= '<a href="'. str_replace( '___', $i, $link_base ) .'">'. $i .'</a> ';
		}

		//

		$dd = 0;
		if ( $step_link && $end_page < $max_page ){
			for( $i = $end_page+1; $i<=$max_page; $i++ ) {
				if( $i % $step_link == 0 && $i !== $num_pages ) {
					if ( ++$dd == 1 ) 
						$out.= '<span class="extend">'. $dotright_text2 .'</span> ';
					$out.= '<a href="'. str_replace( '___', $i, $link_base ) .'">'. $i .'</a> ';
				}
			}
		}
		//

		if ( $end_page < $max_page ) {
			if( $dotright_text && $end_page != ($max_page-1) ) 
				$out.= '<span class="extend">'. $dotright_text2 .'</span> ';
			$out.= '<a class="last" href="'. str_replace( '___', $max_page, $link_base ) .'">'. ( $last_page_text ? $last_page_text : $max_page ) .'</a> ';
		}
		//

		if ( $next_text && $paged != $end_page ) 
			$out.= '<a class="next" href="'. str_replace( '___', ($paged+1), $link_base ) .'">'. $next_text .'</a> ';

	$out .= "</div>". $after ."\n";

	$out = apply_filters('kama_pagenavi', $out );

	if( $echo )
		return print $out;

	return $out;
}

/**
 * 
 */ 
 
?>